## rock-master-20.01-slam-maps 0.20191118

=== CMakeLists.txt ===
# CMakeLists.txt has to be located in the project folder and cmake has to be
# executed from 'project/build' with 'cmake ../'.
cmake_minimum_required(VERSION 2.6)
set(ROCK_USE_CXX11 TRUE)
find_package(Rock)

if(COVERAGE)
    if(CMAKE_BUILD_TYPE MATCHES Debug)
        add_definitions(-fprofile-arcs -ftest-coverage)
        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fprofile-arcs -ftest-coverage -lgcov")
        set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -fprofile-arcs -ftest-coverage -lgcov")
        set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -fprofile-arcs -ftest-coverage -lgcov")

        add_custom_target(coverage
          COMMAND lcov --directory . --capture --output-file cov.info
          COMMAND lcov --remove cov.info 'tests/*' '/usr/*' '*/install/include/*' --output-file cov.info.cleaned
          COMMAND genhtml -o ./cov cov.info.cleaned
          COMMAND cmake -E remove cov.info cov.info.cleaned
          WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
        )
    else()
        message(FATAL_ERROR "Code coverage only works in Debug versions" )
    endif()
endif()

if(CMAKE_BUILD_TYPE MATCHES Debug)
    add_definitions(-O1) # without any optimization, code is extreamly slow
endif()

add_definitions(-DNUMERIC_DEPRECATE=1 )

rock_init(maps 0.1)
rock_standard_layout()

=== src/CMakeLists.txt ===
find_package(Boost REQUIRED COMPONENTS system filesystem serialization)
find_package(CGAL REQUIRED COMPONENTS Core)
find_package(PCL 1.7 REQUIRED COMPONENTS common io)

rock_library(maps
    SOURCES
        grid/ElevationMap.cpp
        grid/TraversabilityMap3d.cpp
        grid/OccupancyGridMap.cpp
        grid/TSDFVolumetricMap.cpp
        tools/BresenhamLine.cpp
        tools/VoxelTraversal.cpp
        tools/TSDFPolygonMeshReconstruction.cpp
        tools/TSDF_MLSMapReconstruction.cpp
    HEADERS
        LocalMap.hpp
        grid/Index.hpp
        grid/GridMap.hpp
        grid/LevelList.hpp        
        grid/LayeredGridMap.hpp
        grid/MultiLevelGridMap.hpp        
        grid/ElevationMap.hpp
        grid/SurfacePatches.hpp
        grid/MLSConfig.hpp
        grid/MLSMap.hpp
        grid/TraversabilityMap3d.hpp
        grid/AccessIterator.hpp
        grid/GridAccessInterface.hpp
        grid/GridFacade.hpp        
        grid/VectorGrid.hpp        
        grid/VectorGridAccess.hpp
        grid/DiscreteTree.hpp
        grid/VoxelGridMap.hpp
        grid/OccupancyGridMapBase.hpp
        grid/OccupancyGridMap.hpp
        grid/OccupancyConfiguration.hpp
        grid/OccupancyPatch.hpp
        grid/TSDFPatch.hpp
        grid/TSDFVolumetricMap.hpp
        geometric/Point.hpp
        geometric/LineSegment.hpp
        geometric/GeometricMap.hpp
        geometric/ContourMap.hpp
        tools/BresenhamLine.hpp
        tools/Overlap.hpp
        tools/VoxelTraversal.hpp
        tools/TSDFSurfaceReconstruction.hpp
        tools/TSDFPolygonMeshReconstruction.hpp
        tools/TSDF_MLSMapReconstruction.hpp
        tools/MarchingCubes.hpp
        tools/SurfaceIntersection.hpp
        operations/GridInterpolation.hpp
    DEPS_PKGCONFIG 
        base-types 
        base-logging
        pcl_common-${PCL_VERSION_MAJOR}.${PCL_VERSION_MINOR}
        pcl_io-${PCL_VERSION_MAJOR}.${PCL_VERSION_MINOR}
        boost_serialization
    DEPS_PLAIN
        Boost_SYSTEM 
        Boost_FILESYSTEM 
        Boost_SERIALIZATION
        CGAL
)

=== test/CMakeLists.txt ===
# TEST GRID MAPS
#
add_subdirectory(grid)

# TEST GEOMETRIC MAPS
#
add_subdirectory(geometric)

# TEST SERIALIZATION
#
add_subdirectory(serialization)

# TEST TOOLS
#
add_subdirectory(tools)

# TEST VISUALIZATION
#
if( vizkit3d_FOUND AND OSGVIZ_PRIMITIVES_FOUND)
    add_subdirectory(viz)
endif()

=== viz/CMakeLists.txt ===
pkg_check_modules(OSGVIZ_PRIMITIVES PrimitivesFactory)

if (vizkit3d_FOUND AND OSGVIZ_PRIMITIVES_FOUND)
    rock_vizkit_plugin(maps-viz
            PluginLoader.cpp
            PatchesGeode.cpp
            StandaloneVisualizer.cpp
        MOC
            GridMapVisualization.cpp
            ElevationMapVisualization.cpp
            MLSMapVisualization.cpp
            TraversabilityMap3dVisualization.cpp
            ContourMapVisualization.cpp
            OccupancyGridMapVisualization.cpp
        HEADERS
            ColorGradient.hpp
            ExtentsRectangle.hpp
            MapVisualization.hpp
            GridMapVisualization.hpp
            ElevationMapVisualization.hpp
            MLSMapVisualization.hpp
            TraversabilityMap3dVisualization.hpp
            PatchesGeode.hpp
            StandaloneVisualizer.hpp
            ContourMapVisualization.hpp
            OccupancyGridMapVisualization.hpp
        DEPS 
            maps
        DEPS_PKGCONFIG 
	    base-logging
            base-viz vizkit3d  vizkit3d-viz
            PrimitivesFactory
    )
else()
    message(STATUS "osgviz not found ... NOT building the maps-viz plugins")
endif()

=== test/geometric/CMakeLists.txt ===
# TEST GEOMETRIC MAPS
#
rock_testsuite(test_geometricmap
   test_GeometricMap.cpp
   DEPS maps)

rock_testsuite(test_point
   test_Point.cpp
   DEPS maps)

rock_testsuite(test_linesegment
    test_LineSegment.cpp
   DEPS maps)

rock_testsuite(test_contourmap
   test_ContourMap.cpp
   DEPS maps)

rock_testsuite(test_closest_MLS
   test_closest_MLS.cpp
   DEPS maps)

=== test/grid/CMakeLists.txt ===
# TEST GRID MAPS
#
rock_testsuite(test_index 
   test_Index.cpp
   DEPS maps)

rock_testsuite(test_vectorgrid
   test_VectorGrid.cpp
   DEPS maps)      

rock_testsuite(test_localmap
   test_LocalMap.cpp
   DEPS maps)

rock_testsuite(test_gridmap
   test_GridMap.cpp
   DEPS maps)

rock_testsuite(test_mlgrid
   test_MLGrid.cpp
   DEPS maps)

rock_testsuite(test_travMap3d
   test_TravMap3d.cpp
   DEPS maps)

rock_testsuite(test_layeredgridmap
   test_LayeredGridMap.cpp
   DEPS maps)

=== test/serialization/CMakeLists.txt ===
# TEST SERIALIZATION
#
rock_testsuite(test_serialization_localmap
   test_serialization_LocalMap.cpp
   DEPS maps)

rock_testsuite(test_serialization_grid
   test_serialization_Grid.cpp
   DEPS maps)

rock_testsuite(test_serialization_geometric
   test_serialization_Geometric.cpp
   DEPS maps)

rock_testsuite(test_serialization_mlsmap
   test_serialization_MLS.cpp
   DEPS maps)
   
rock_testsuite(test_serialization_travmap
   test_serialization_TravMap.cpp
   DEPS maps)

rock_testsuite(test_serialization_discreteTree
    test_serialization_DiscreteTree.cpp
    DEPS maps)

# Testfiles.
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/DiscreteTree_v0.bin
               ${CMAKE_CURRENT_BINARY_DIR}/DiscreteTree_v0.bin COPYONLY)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/TravMap_v00.bin
               ${CMAKE_CURRENT_BINARY_DIR}/TravMap_v00.bin COPYONLY)

=== test/tools/CMakeLists.txt ===
# TEST TOOLS
#
rock_testsuite(test_tools_generatepoints
   test_tools_GeneratePoints.cpp
   DEPS maps)

rock_testsuite(test_voxel_traversal
   test_voxel_traversal.cpp
   DEPS maps)

rock_testsuite(test_surface_intersection
   test_surface_intersection.cpp
   DEPS maps)

=== test/viz/CMakeLists.txt ===
include_directories(BEFORE ${PROJECT_SOURCE_DIR}/viz)
rock_find_qt4(QtCore QtGui)

rock_executable(heightmap_to_mls
    SOURCES
    mlsFromImageHeightmap.cpp
    HEADERS    
   DEPS_PKGCONFIG QtCore QtGui vizkit3d vizkit3d-viz
   DEPS maps-viz maps)


rock_testsuite(test_viz_elevationmap 
    test_viz_ElevationMap.cpp
    DEPS maps-viz
    DEPS_PKGCONFIG vizkit3d  vizkit3d-viz)

rock_testsuite(test_viz_mlsmap
    test_viz_MLSMap.cpp
    DEPS maps-viz
    DEPS_PKGCONFIG vizkit3d  vizkit3d-viz)

rock_testsuite(test_viz_mlslidar 
    test_viz_MLSLIDAR.cpp
    DEPS maps-viz
    DEPS_PKGCONFIG vizkit3d  vizkit3d-viz)

rock_testsuite(test_viz_countourmap
    test_viz_ContourMap.cpp
    DEPS maps-viz
    DEPS_PKGCONFIG vizkit3d  vizkit3d-viz)

rock_testsuite(test_viz_gridmap
    test_viz_GridMap.cpp
    DEPS maps-viz
    DEPS_PKGCONFIG vizkit3d  vizkit3d-viz)

rock_executable(deserialize_test 
    DeserializeVizTest.cpp
    DEPS_CMAKE Boost
    DEPS maps-viz
    DEPS_PKGCONFIG vizkit3d  vizkit3d-viz)

rock_testsuite(test_viz_tsdf_map
    test_viz_TSDFMap.cpp
    DEPS maps-viz
    DEPS_PKGCONFIG vizkit3d vizkit3d-viz)

rock_testsuite(test_viz_occupancylidar
    test_viz_OccupancyLidar.cpp
    DEPS maps-viz
    DEPS_PKGCONFIG vizkit3d  vizkit3d-viz)

=== debian/changelog ===
rock-master-20.01-slam-maps (0.20191118-1~bionic) unstable; urgency=low

  * Package automatically built using 'apaka'
  * repository: github:/envire/slam-maps.git
  * branch: refs/heads/master
  * commit: 52feb1124f86f05d65e96af2d5833749c5f6b0d1
  * tag: 

 -- Rock Packaging Daemon (based on apaka) <rock-dev@dfki.de>  Mon, 24 Feb 2020 14:11:12 +0100

=== debian/control ===
Source: rock-master-20.01-slam-maps
Section: science
Priority: optional
Maintainer: Rock Packaging Daemon (based on apaka) <rock-dev@dfki.de>
Uploaders: Rock Packaging Daemon (based on apaka) <rock-dev@dfki.de>
Build-Depends: cdbs, debhelper (>= 8.0.0), pkg-config, dh-autoreconf, cmake, libboost-dev, libboost-filesystem-dev, libboost-graph-dev, libboost-iostreams-dev, libboost-program-options-dev, libboost-regex-dev, libboost-serialization-dev, libboost-system-dev, libboost-thread-dev, libcgal-dev, libgdal-dev, libpcl-dev, rock-master-20.01-base-boost-serialization, rock-master-20.01-base-cmake, rock-master-20.01-base-numeric, rock-master-20.01-base-types, rock-master-20.01-gui-osgviz, rock-master-20.01-gui-vizkit3d
Standards-Version: 3.9.2
Homepage: http://www.rock-robotics.org

Package: rock-master-20.01-slam-maps
Architecture: any
Depends: ${shlibs:Depends}, rock-master-20.01-base-boost-serialization, rock-master-20.01-base-cmake, rock-master-20.01-base-numeric, rock-master-20.01-base-types, rock-master-20.01-gui-osgviz, rock-master-20.01-gui-vizkit3d, cmake, libpcl-dev, libboost-dev, libboost-graph-dev, libboost-program-options-dev, libboost-regex-dev, libboost-thread-dev, libboost-filesystem-dev, libboost-iostreams-dev, libboost-system-dev, libboost-serialization-dev, libcgal-dev, libgdal-dev
Description: Standard Maps library
 Standard Maps library following the IEEE 1873 standard for mapa data representation with extensions (i.e: MLS, 3D, Operators, etc..)

=== debian/rules ===
#!/usr/bin/make -f

# BEGIN ENVIRONMENT SETUP
# https://www.debian.org/doc/debian-policy/ch-source.html
# nocheck: This tag says to not run any build-time test suite provided by the package.
export DEB_BUILD_OPTIONS=nocheck

# Setup of $(arch), $(rockruby_libdir) and $(rockruby_archdir)
arch=$(shell gcc -print-multiarch)
ruby_ver=$(shell ruby --version)
ruby_arch_dir=$(shell ruby -r rbconfig -e "print RbConfig::CONFIG['archdir']")
ruby_libdir=$(shell ruby -r rbconfig -e "print RbConfig::CONFIG['rubylibdir']")
rockruby_archdir=$(subst /usr,,$(ruby_arch_dir))
rockruby_libdir=$(subst /usr,,$(ruby_libdir))
# Setup of paths: PATH,PKG_CONFIG_PATH,RUBYLIB,...
master2001_install_dir = /opt/rock/master-20.01
env_setup =  PATH=$(master2001_install_dir)/bin:$(PATH)
env_setup += HOME=/home/ 
env_setup += RUBYLIB=$(master2001_install_dir)/$(rockruby_libdir):$(master2001_install_dir)/$(rockruby_archdir):$(master2001_install_dir)/lib/ruby/vendor_ruby/standard:$(master2001_install_dir)/lib/ruby/vendor_ruby/core:$(master2001_install_dir)/lib/ruby/vendor_ruby:$(RUBYLIB)
env_setup += PKG_CONFIG_PATH=$(master2001_install_dir)/lib/pkgconfig:$(master2001_install_dir)/lib/$(arch)/pkgconfig:/usr/share/pkgconfig:/usr/lib/$(arch)/pkgconfig:$(PKG_CONFIG_PATH)
env_setup += Rock_DIR=$(master2001_install_dir)/share/rock/cmake:$(Rock_DIR)
env_setup += LD_LIBRARY_PATH=$(master2001_install_dir)/lib:$(master2001_install_dir)/lib/$(arch):$(LD_LIBRARY_PATH)
env_setup += CMAKE_PREFIX_PATH=$(master2001_install_dir):$(CMAKE_PREFIX_PATH)
env_setup += OROGEN_PLUGIN_PATH=$(master2001_install_dir)/share/orogen/plugins:$(OROGEN_PLUGIN_PATH)
export TYPELIB_CXX_LOADER=castxml
export DEB_CPPFLAGS_APPEND=-std=c++11
export npm_config_cache=/tmp/npm
rock_library_dirs=$(master2001_install_dir)/lib:$(master2001_install_dir)/lib/$(arch):
rock_install_dir=/opt/rock/master-20.01
# Check if a python command is available and identify the version
# and identify the setup.py file
python_cmd=$(shell command -v python 2> /dev/null)
ifneq ("$(python_cmd)","")
python_version=$(shell python -c 'import sys; print "{0}.{1}".format(sys.version_info[0],sys.version_info[1])')
# Get dirname a setup.py match
python_setup_dir=$(shell find $(DEB_SRCDIR) -name setup.py | tail -n 1 | xargs dirname)
endif

DEB_VERBOSE_ALL=1
include /usr/share/cdbs/1/rules/debhelper.mk
extra_lib_dir=$(shell pwd)/debian/rock-master-20.01-slam-maps$(rock_install_dir)/lib
# This argument list is forwarded to dh_shlibdeps which takes the -l option and a colon separated list of libraries
# (not that this is different from the linker arguments)
DEB_DH_SHLIBDEPS_ARGS_ALL=-l$(extra_lib_dir):$(extra_lib_dir)/$(arch):$(rock_library_dirs)

rock_doc_install_dir=$(rock_install_dir)/share/doc/rock-master-20.01-slam-maps

pre-build::
	echo "Detected:"
	echo "   ruby version: $(ruby_ver)"
	echo "   ruby libdir: $(rockruby_libdir)"
	echo "   ruby archdir: $(rockruby_archdir)"

	#echo "Current directory:"
	#find .

# END ENVIRONMENT SETUP
######################################
# BEGIN OROGEN -- This block needs to be executed before CMAKE


# END OROGEN
######################################
# BEGIN CMAKE
#
# Defining the cmake command and setting the required enviroment variables
# PKG_CONFIG_PATH Resolve Rock package via pkg-config
# Rock_DIR Set to make sure find_package(Rock) does work
# ROCK_CMAKE_MACROS Used in some patches to set the CMAKE_MODULE_PATH, allowing to find Rock.cmake
CMAKE = $(env_setup) cmake
DEB_CMAKE_INSTALL_PREFIX = $(rock_install_dir)

# Debian packaging discourages the use of rpath, but
# cdbs actively sets CMAKE_SKIP_RPATH=ON, so reinforcing OFF here
DEB_CMAKE_EXTRA_FLAGS = -DCMAKE_SKIP_RPATH=OFF
# Telling FindGEM.cmake to search for os packages using pkg-config and not for gems
DEB_CMAKE_EXTRA_FLAGS += -DGEM_OS_PKG=TRUE
# Leaving RUBY_EXECUTABLE unset since it maps to a path of the user executing the upload script
DEB_CMAKE_EXTRA_FLAGS += -DCMAKE_EXPORT_COMPILE_COMMANDS="ON" -DROCK_USE_CXX11="ON"
# Disable ROCK Testing -- since running test on the OBS would require proper setting of path, etc. (see. data_processing/type_to_vector)
DEB_CMAKE_EXTRA_FLAGS += -DROCK_TEST_ENABLED=OFF -UROCK_TEST_LOG_DIR
include /usr/share/cdbs/1/class/cmake.mk

# END CMAKE
##########################################
# BEGIN AUTOTOOLS
#


# http://cdbs-doc.duckcorp.org/en/cdbs-doc.xhtml see post-configure actions
# replace all entries of -I with -I and -isystem in order to 
#   (a) guarantee that pkgconfig can still knowns the include directory (-I)
#   (b) the include directory is actually accounted for as system include directory (-isystem)
# Account for the fact, that configure is called multiple times e.g. revert changes first, then reapply
configure/rock-master-20.01-slam-maps::
	echo "Adapt -I to -isystem in pkgconfig files:"
	find . -name '[a-zA-Z]*.pc' -exec sh -c "echo Adapting {}; sed -i 's#\(\"\?\)-isystem[^ ]\+\1##g; s#\(\"\?\)-I\([^ ]\+\)\1#\1-I\2\1 \1-isystem\2\1#g; s#[ ]\+# #g' {}; cat {};" \;
	find . -name '[a-zA-Z]*.pc' -exec sh -c "echo Cleanup {}; sed -i 's#-isystem/usr/include # #g' {}; sed -i 's#-I/usr/include # #g' {}; cat {}" \;

###########################################
# DOCS


# Build docs
# This checks for Doxyfile and runs doxygen with that.
# Otherwise, it tries the "doc" target.
# Since docs are not critical, ignore failures('-' on recipe line start).
# The make call is supposed to be invoked even if -t or -n is selected,
# with the appropriate flags('+' on recipe line start)

common-build-arch common-build-indep:: debian/stamp-rock-doc
debian/stamp-rock-doc:
	-+$(DEB_MAKE_INVOKE) doc
	touch $@

common-install-arch common-install-indep:: common-install-rock-doc install-extensions
common-install-rock-doc::
	mkdir -p $(DEB_DESTDIR)$(rock_doc_install_dir)
	$(if $(wildcard $(DEB_SRCDIR)/doc/html),-cp -r "$(DEB_SRCDIR)/doc/html" "$(DEB_DESTDIR)$(rock_doc_install_dir)",$(if $(wildcard $(DEB_SRCDIR)/doc),-cp -r "$(DEB_SRCDIR)/doc" "$(DEB_DESTDIR)$(rock_doc_install_dir)"))
	$(if $(wildcard $(DEB_BUILDDIR)/doc/html),-cp -r "$(DEB_BUILDDIR)/doc/html" "$(DEB_DESTDIR)$(rock_doc_install_dir)",$(if $(wildcard $(DEB_BUILDDIR)/doc),-cp -r "$(DEB_BUILDDIR)/doc" "$(DEB_DESTDIR)$(rock_doc_install_dir)"))

install-extensions:: install-python
install-python::
ifneq ("$(python_setup_dir)","")
	echo "Installing python extension in $(python_setup_dir)"
	mkdir -p $(DEB_DESTDIR)$(rock_install_dir)/lib/python$(python_version)/site-packages
	cd $(python_setup_dir); $(python_cmd) setup.py build; PYTHONPATH=$(DEB_DESTDIR)$(rock_install_dir)/lib/python$(python_version)/site-packages/ $(python_cmd) setup.py install --prefix=$(DEB_DESTDIR)$(rock_install_dir); cd -
endif

clean::
	rm -f debian/stamp-rock-doc
	rm -rf $(DEB_SRCDIR)/doc/html


# END DOCS
###########################################
